/* 
   Trivial demo code to exercise the USBMicro USB4xx devices under 
   Linux.  Makes use of the code in usbmicro4xx.[ch] as well as 
   libusb to actually talk to the device.

   Code isn't meant to be exhaustive and has only had basic testing
   but you should get the idea.

   Loosely based on sample code provided by USBMicro which we were
   told could be used any way we liked, including as part of a GPL'd
   package.

   (C) 2008,2009 Hugh Blemings, hugh@blemings.org

   Licensed under the GNU Public Licence V3

*/


#include <stdio.h>
#include <usb.h>

#include "usbmicro4xx.h"



int main() 
{

	struct usb_dev_handle *handle;

	/* initialize the usb4xx support code */
	handle = usb4xx_init();
	if (!handle) {
		fprintf(stderr, "Couldn't initialise usb4xx subsystem :(\n");
		return (-1);
	}

	/* Initialise ports on the USB4xx hardware */
	usb4xx_init_ports(handle);

	/* Want port A and port B as inputs */
	usb4xx_direction_a_bit(handle, 0x00, 0x00);
	usb4xx_direction_b_bit(handle, 0x00, 0x00);

	/* Loop forever reading PORTA and PORTB pins */
	while (1) {
		printf("PortA: %d\n", usb4xx_read_a(handle));
		printf("PortB: %d\n", usb4xx_read_b(handle));

		sleep(1);
	}
	
	/* Never get here of course, but in your own immaculately coded
           version this is how to tidy up :) */
	usb4xx_close(handle);

	return 0; 
}

